//----------------------------------------------------------------------------------------------------------------------------------------------------//
//									    Drift correction											//
//																							//
//										F. Cheynis											//
//																							//
//										26/06/2017											//
//----------------------------------------------------------------------------------------------------------------------------------------------------//


//	26/06/2017 Version:	Button added to 'Cancel' the drift correction procedure.




#pragma rtGlobals=1		// Use modern global access method.

//Menu "GraphMarquee"
//	"Correct drift", GraphMarqueeDriftCorrection()
//End
//
//
//Function GraphMarqueeDriftCorrection() //: GraphMarquee
//
//	Nvar MovFileLoaded, RefRead, FrameNumber
//	
//	If(MovFileLoaded==0)
//	
//	EndIf	
//
//End


Function DAVDrift(ctrlName) : ButtonControl
	String ctrlName
	
	Nvar FromVar, ToVar, StepVar, RefRead,FrameNumber,DoesCursorAExist
	Svar YesNoStr, ManualStr
	
	Variable /g RefWrite
	
	Variable Flag, i,NFramesToCorrect, TempVar
	Variable pdrift,qdrift,SumDrift,FirstWhile=1
	
	String TempStr
	
	//WMCreateImageROIPanel()
	
	Flag=FromToStepDialog(3)
	
	NFramesToCorrect=(ToVar-FromVar)/StepVar+1
	DoesCursorAExist=0
	
	TempStr=StrVarOrDefault("root:TopImageWinName","nop!")
	If(stringmatch(TempStr,"nop!"))
		String/G TopImageWaveName,TopImageWinName
	Else
		Svar TopImageWaveName,TopImageWinName
	EndIf
	TopImageWinName=WinName(0,1,1)
	
	If(Flag==0)
		STRUCT UKFileHeader MyFileHeader 
		Fstatus RefRead
		
		open/F="Data Files (*.dav):.dav;All Files:.*;" RefWrite as StringFromList(0, S_fileName,".")+"_drift.dav"
		//open/P=MyPath/F="Data Files (*.dav):.dav;All Files:.*;" RefWrite as StringFromList(0, S_fileName,".")+"_drift.dav"
		
		fsetpos RefRead,0
		fsetpos RefWrite,0
		
		FBinRead RefRead, MyFileHeader
		FBinWrite RefWrite, MyFileHeader
	Else
		Abort  "Drift correction procedure cancelled"
	EndIf
	
//----------------------------------------------------------------------------------------------------------------------------------------------------------//
//								Manual Drift 														//
//----------------------------------------------------------------------------------------------------------------------------------------------------------//

	If(stringmatch(ManualStr,"Yes") )
	
		String Str
		Variable Np,Nq
		Nvar FromVar, ToVar, StepVar		
		
		Str=StrVarOrDefault("root:TopImageWinName","nop!")
		If(stringmatch(str,"nop!"))
			String/G TopImageWaveName,TopImageWinName
		Else
			Svar TopImageWaveName,TopImageWinName
		EndIf
		TopImageWinName=WinName(0,1,1)		
		DAVAddFrame(FromVar,"Yes")
		
		TopImageWaveName=StringFromList(0,ImageNameList("",";"),";")
		Np=round(dimsize($TopImageWaveName,0)/2)
		Nq=round(dimsize($TopImageWaveName,1)/2)
		
		If(Exists("XPos")!=0&&Exists("YPos")!=0)
			Wave XPos,YPos,SampleWave
			Redimension/D /N=0 XPos,YPos,SampleWave
		EndIf		
		
		cursor/C=(65535,0,0)/I/H=1/W=$TopImageWinName A, $TopImageWaveName,Np,Nq
		Button PosAddButton win=$TopImageWinName,title="Add Pos.",pos={550,530},size={60,18},proc=DriftManAdd,disable=0//,appearance={os9}
		Button PosRemoveButton win=$TopImageWinName,title="Rmve Pos.",pos={550,550},size={60,18},proc=DriftManRemove,disable=0//,appearance={os9}
		Button PosStartButton win=$TopImageWinName,title="Start",pos={550,570},size={60,18},proc=DriftManStart,disable=0//,appearance={os9}
		Button PosCancelButton win=$TopImageWinName,title="Cancel",pos={550,590},size={60,18},proc=DriftManCancel,disable=0//,appearance={os9}
		Slider DAVslider,limits={FromVar,ToVar,StepVar}
		FrameNumber=FromVar
		
		Print " Correcting drift manually"
	Endif

//----------------------------------------------------------------------------------------------------------------------------------------------------------//
//								Automated Drift Procedure											//
//----------------------------------------------------------------------------------------------------------------------------------------------------------//
		
	If(stringmatch(ManualStr,"No") )
				
		DoWindow /K $TopImageWinName
	
		Wave 'Wave_i'=DAVLoadFrame(FromVar,0)
		DAVWriteFrame(NameOfWave('Wave_i'),0,"AutoDAVDrift")
		//DAVExtractFrame(FromVar,0,"dav")//,1)
				
		If(StringMatch(YesNoStr,"Yes"))
			// ROI mask used
			
			If(!Exists("M_ROIMask"))
				Abort "You need to create a ROI first"
			EndIf
			Fstatus RefRead
			Print S_fileName
			
			do	
				SumDrift=0
				
				If(FirstWhile)
//					Wave 'Wave_i'=DAVLoadFrame(FromVar,0)
				Else
					RefRead=RefWrite
//					Wave 'Wave_i'=DAVLoadFrame(0,0)
//					//Wave 'Wave_i'=$("Frame"+Num2str(FromVar+i*StepVar))
//					//Wave 'Wave_i+1'=$("Frame"+Num2str(FromVar+i*StepVar+StepVar))
				EndIf
//				

//				
//				Wave 'Wave_i_extracted'=FromROIToROIImage(NameOfWave('Wave_i'))
//				//WriteFrame(NameOfWave('Wave_i'),0)
//				Np=DimSize('Wave_i_extracted',0)
//				Nq=DimSize('Wave_i_extracted',1)
//				
//				make/D/O/n=(Np,Nq) Hann
//				Hann=sin(pi*p/Np)*sin(pi*q/Nq)
				
				Print " Correcting drift automatically"
				
				For(i=0; i<NFramesToCorrect-1; i+=1)
					If(FirstWhile)
						Wave 'Wave_i'=DAVLoadFrame(FromVar+i*StepVar,0)
						Wave 'Wave_i+1'=DAVLoadFrame(FromVar+i*StepVar+StepVar,0)
					Else
						//RefRead=RefWrite
						Wave 'Wave_i'=DAVLoadFrame(i,0)
						Wave 'Wave_i+1'=DAVLoadFrame(i+1,0)
						//Wave 'Wave_i'=$("Frame"+Num2str(FromVar+i*StepVar))
						//Wave 'Wave_i+1'=$("Frame"+Num2str(FromVar+i*StepVar+StepVar))
					EndIf

					Wave 'Wave_i_extracted'=FromROIToROIImage(NameOfWave('Wave_i'))
					Wave 'Wave_i+1_extracted'=FromROIToROIImage(NameOfWave('Wave_i+1'))
										
//					Np=DimSize('Wave_i_extracted',0)
//					Nq=DimSize('Wave_i_extracted',1)
//					
//					make/D/O/n=(Np,Nq) Hann
//					Hann=sin(pi*p/Np)*sin(pi*q/Nq)

								
					MatrixOP/O 'Wave_i_extracted'=subtractMean('Wave_i_extracted',0)
					MatrixOP/O 'Wave_i+1_extracted'=subtractMean('Wave_i+1_extracted',0)
															
//					MatrixOP/O 'Wave_i_extracted'='Wave_i_extracted'*Hann
//					MatrixOP/O 'Wave_i+1_extracted'='Wave_i+1_extracted'*Hann
					
					ImageWindow/O Hanning 'Wave_i_extracted'
					ImageWindow/O Hanning 'Wave_i+1_extracted'
					
					Duplicate/O 'Wave_i_extracted', Correl
					MatrixOP/O Correl=correlate('Wave_i_extracted' ,'Wave_i+1_extracted',0)
					Imagestats/M=1 Correl
					//Print  V_MaxRowLoc, V_MaxColLoc
					
					if (V_MaxColLoc >= DimSize(Correl,1)/2)
				       	qdrift = -DimSize(Correl,1)+V_MaxColLoc
				      	else
				      		qdrift=V_MaxColLoc     
				 	endif
				 	if (V_MaxRowLoc >=  DimSize(Correl,0)/2)
				       	pdrift = -DimSize(Correl,0)+V_MaxRowLoc
					else      
				      		pdrift=V_MaxRowLoc     
				      endif
				      
				      print NameOfWave('Wave_i'),NameOfWave('Wave_i+1'),"pdrift=",pdrift,"qdrift=",qdrift
				      
				   	Duplicate/O 'Wave_i+1', TempWave
				   	'Wave_i+1'=TempWave[p+pdrift][q+qdrift]
				   					   	
//				     	Duplicate/O 'Wave_i+1_extracted',w
//				     	'Wave_i+1_extracted'=w[p+pdrift][q+qdrift]
				     					     	
				   	WaveStats/M=1/Q 'Wave_i+1_extracted'	
				   	MatrixOP/O 'Wave_i+1'='Wave_i+1'-V_avg
				     	
				    	DAVWriteFrame(NameOfWave('Wave_i+1'),i+1,"AutoDAVDrift")
									      	      
				    //  Duplicate/O 'Wave_i+1', 'Wave_i'
				     // Duplicate/O 'Wave_i+1_extracted', 'Wave_i_extracted'
				      
				      TempStr=NameOfWave('Wave_i+1')
				     	//print "TempStr=",TempStr
				     	
				      KillWaves 'Wave_i+1','Wave_i+1_extracted',TempWave
				      KillWaves 'Wave_i','Wave_i_extracted'
				     	//Rename   'Wave_i', $TempStr
				      //TempStr+="_extracted"
				     	//Rename 'Wave_i_extracted',$TempStr 
				      
				      SumDrift+=abs(pdrift)
				      SumDrift+=abs(qdrift)
				EndFor
				
				print "SumDrift=",SumDrift, "\r\r"
				FirstWhile=0
				Close RefWrite
			While(SumDrift>2)
		Else
			// ROI mask not used
			Abort "Not implemented Yet!"
		EndIf
	EndIf

End

//----------------------------------------------------------------------------------------------------------------------------------------------------------//
//								Manual Drift 	Procedures											//
//----------------------------------------------------------------------------------------------------------------------------------------------------------//

Function DriftManAdd(ctrlName) : ButtonControl
	String ctrlName
	
	Svar TopImageWinName,TopImageWaveName
	
	String Str,Str2
	
	If(Exists("XPos")==0&&Exists("YPos")==0)
		Make/D/N=1/O XPos,YPos, SampleWave
		XPos[0]=hcsr(A)
		YPos[0]=vcsr(A)
		Str="Text"+num2str(0)
		SplitString /E="(\\d+)" TopImageWaveName,Str2
		SampleWave[0]=str2num(Str2)			
	Else
		Wave XPos,YPos, SampleWave
		Wavestats/Q/Z/M=1 XPos
		Redimension/D/N=(V_npnts+1) XPos,YPos, SampleWave
		XPos[V_npnts]=hcsr(A)
		YPos[V_npnts]=vcsr(A)
		Str="Text"+num2str(V_npnts)
		SplitString /E="(\\d+)" TopImageWaveName,Str2
		SampleWave[V_npnts]=str2num(Str2)	
	EndIf
	//ShowTools/A
//	SetDrawEnv/W=$TopImageWinName textrgb= (2^32,0,0),fstyle= 1,xcoord= top,ycoord= left
//	SetDrawEnv gname=$Str,gstart
//	DrawText hcsr(A),vcsr(A)-10, num2str(V_npnts)
//	SetDrawEnv gname=$Str,gstop	
	//HideTools/A
	
End


Function DriftManRemove(ctrlName) : ButtonControl
	String ctrlName
	
	Svar TopImageWinName
	
	Wave  XPos,YPos, SampleWave
	String Str
	
	TopImageWinName=WinName(0,1,1)
	
	Wavestats/Q/Z/M=1 XPos
	
	If(V_npnts>=0)
		Redimension/D/N=(V_npnts-1) XPos,YPos, SampleWave
//		Str="Text"+num2str(V_npnts-1)
//		DrawAction/W=$TopImageWinName getgroup=$Str, delete
	EndIf
	//Return V_npnts
End

Function DriftManStart(ctrlName) : ButtonControl
	String ctrlName	
	
//	Variable Nclicked=0,i
//	Slider Driftslider,pos={5,454},size={502,20},limits={0,4,1},value= 0,vert= 0
//	Slider Driftslider,win=TopImageWinName,variable= FrameNumber,vert= 0,ticks= 10

	Nvar FromVar, ToVar, StepVar, RefRead, RefWrite,NFrames,FrameNumber
	Svar TopImageWaveName,TopImageWinName
	
	if (Exists("SampleWave")==0)
	 	abort "Abort - at least two positions for drift correction are required" 
	EndIf
	
	Wave  XPos,YPos,SampleWave
	
	WaveStats/Q/M=1/Z SampleWave
	Variable NFramesToCorrect=(ToVar-FromVar)/StepVar+1,NSamples=V_npnts
	Variable Xdrift=0,Ydrift=0,i=0,j=0,TempVar=0, XdriftLast=0,YdriftLast=0
	
	Dowindow/K $TopImageWinName

//		
//		Variable Np, Nq
//		Make/W/U/N=5/O Pwave, Qwave, SampleWave
//				
//		For(i=0; i<5; i+=1)
//			SampleWave[i]=floor(FromVar+(i*StepVar)*(NFramesToCorrect-1)/4)
//			Wave 'Wave_i'=DAVLoadFrame(SampleWave[i],1)
//			TempStr=NameOfWave('Wave_i')
//		     	//print "TempStr=",TempStr
//			TopImageWinName=WinName(0,1,1)
//			//TopImageWaveName=StringFromList(0,ImageNameList("",";"),";")
//			Np=round(dimsize('Wave_i',0)/2)
//			Nq=round(dimsize('Wave_i',1)/2)
//			//print Np, Nq
//			cursor/C=(65535,0,0)/I/H=1/W=$TopImageWinName A, 'Wave_i',Np,Nq
//			
//			NewPanel /K=2 /W=(40,619,246,716) as "Pause for Cursor"
//			DoWindow/C PauseforCursor					// Set to an unlikely name
//			AutoPositionWindow/E/M=0/R=$TopImageWinName		// Put panel near the graph
//			DrawText 21,37,"Adjust the cursor and then"
//			DrawText 21,54,"Click Continue."
//			Button button0,pos={49,56},size={92,20},title="Continue"
//			Button button0, proc=KillPauseforCursorPanel
//			
//			DoWindow/F $TopImageWinName
//			cursor/C=(65535,0,0)/I/H=1/W=$TopImageWinName A, $TempStr,Np,Nq
//			PauseForUser PauseforCursor,$TopImageWinName
//			
//			Pwave[i]=pcsr(A); Qwave[i]=qcsr(A)
//			//Button ContinueButton win=$TopImageWinName,title="Continue.",pos={450,430},size={60,18},proc=PartAdd//,appearance={os9}
//			DoWindow /K $TopImageWinName
//			KillWaves 'Wave_i'
//		EndFor
//	
		
		For(i=0; i<NFramesToCorrect; i+=1)
			TempVar=FromVar+i*StepVar	
			Wave 'Wave_i'=DAVLoadFrame(TempVar,0)
			Duplicate/O 'Wave_i', TempWave
			
			For(j=0;j<NSamples-1;j+=1)
				If(TempVar>SampleWave[j] && TempVar<=SampleWave[j+1])
//					Xdrift=round((TempVar-SampleWave[j])*(XPos[j+1]-XPos[j])/(SampleWave[j+1]-SampleWave[j]))
//					Ydrift=round((TempVar-SampleWave[j])*(YPos[j+1]-YPos[j])/(SampleWave[j+1]-SampleWave[j]))
//					Xdrift=round((XPos[j+1]-XPos[0])*(TempVar-SampleWave[0])/(SampleWave[j+1]-SampleWave[0]))
//					Ydrift=round((YPos[j+1]-YPos[0])*(TempVar-SampleWave[0])/(SampleWave[j+1]-SampleWave[0]))
					Xdrift=round(XdriftLast+(XPos[j+1]-XPos[j])*(TempVar-SampleWave[j])/(SampleWave[j+1]-SampleWave[j]))
					Ydrift=round(YdriftLast+(YPos[j+1]-YPos[j])*(TempVar-SampleWave[j])/(SampleWave[j+1]-SampleWave[j]))
					If(TempVar==SampleWave[j+1])
						XdriftLast=Xdrift ; YdriftLast=Ydrift
					EndIf					
				EndIf
			EndFor
			
//			if(TempVar<SampleWave[1])
//				pdrift=floor((TempVar-SampleWave[0])*(Pwave[1]-Pwave[0])/(SampleWave[1]-SampleWave[0]))
//				qdrift=floor((TempVar-SampleWave[0])*(Qwave[1]-Qwave[0])/(SampleWave[1]-SampleWave[0]))
//			ElseIf(TempVar<SampleWave[2])
//				pdrift=floor((TempVar-SampleWave[1])*(Pwave[2]-Pwave[1])/(SampleWave[2]-SampleWave[1])+Pwave[1]-Pwave[0])
//				qdrift=floor((TempVar-SampleWave[1])*(Qwave[2]-Qwave[1])/(SampleWave[2]-SampleWave[1])+Qwave[1]-Qwave[0])
//			Else
//				If(TempVar<SampleWave[3])
//					pdrift=floor((TempVar-SampleWave[2])*(Pwave[3]-Pwave[2])/(SampleWave[3]-SampleWave[2])+Pwave[2]-Pwave[0])
//					qdrift=floor((TempVar-SampleWave[2])*(Qwave[3]-Qwave[2])/(SampleWave[3]-SampleWave[2])+Qwave[2]-Qwave[0])
//				Elseif(TempVar<=SampleWave[4])
//					pdrift=floor((TempVar-SampleWave[3])*(Pwave[4]-Pwave[3])/(SampleWave[4]-SampleWave[3])+Pwave[3]-Pwave[0])
//					qdrift=floor((TempVar-SampleWave[3])*(Qwave[4]-Qwave[3])/(SampleWave[4]-SampleWave[3])+Qwave[3]-Qwave[0])
//				EndIf
//			EndIf
			
		   	'Wave_i'=TempWave[p+Xdrift][q+Ydrift]
		     	print NameOfWave('Wave_i'),"drift in X=",Xdrift,"drift in Y=",Ydrift				     	
		   	//WaveStats/M=1/Q 'Wave_i'	
		   	//MatrixOP/O 'Wave_i'='Wave_i'-V_avg
		     	
		    	DAVWriteFrame(NameOfWave('Wave_i'),i,ctrlName)
		    		 
		      KillWaves 'Wave_i',TempWave
		EndFor
//		Button PosAddButton win=$TopImageWinName,disable=3
//		Button PosRemoveButton win=$TopImageWinName,disable=3
//		Button PosStartButton win=$TopImageWinName,disable=3
//		cursor/K/W=$TopImageWinName A
		FrameNumber=0
//		Slider DAVslider, limits={0,NFrames-1,1} ,disable=0,win=LEEM
		
//		RefRead=RefWrite
//		DAVLoadFrame(0,1)
//		Close RefWrite
End

Function DriftManCancel(ctrlName) : ButtonControl
	String ctrlName	
	
//	Variable Nclicked=0,i
//	Slider Driftslider,pos={5,454},size={502,20},limits={0,4,1},value= 0,vert= 0
//	Slider Driftslider,win=TopImageWinName,variable= FrameNumber,vert= 0,ticks= 10

	Nvar RefWrite,FrameNumber,NFrames
	Svar TopImageWinName
	
	cursor/W=$TopImageWinName/K A
	Button PosAddButton win=$TopImageWinName,disable=3//,appearance={os9}
	Button PosRemoveButton win=$TopImageWinName,disable=3
	Button PosStartButton win=$TopImageWinName,disable=3
	Button PosCancelButton win=$TopImageWinName,disable=3
	Slider DAVslider,limits={0,NFrames-1,1},win=LeemPanel2015
	FrameNumber=0
	Close RefWrite
End