//----------------------------------------------------------------------------------------------------------------------------------------------------------//
//									Particle Analysis												//
//																								// 
//										F. Cheynis												//
//																								//
//										06/06/2014												//
//----------------------------------------------------------------------------------------------------------------------------------------------------------//


//	25-01-2010 :	Particle Analysis in DAV movies updated 
//	06/006/2014: Particle Perimeters determined and stored



#pragma rtGlobals=1		// Use modern global access method.
#include <All IP Procedures>


Function DAVPart(ctrlName) : ButtonControl
	String ctrlName
	
	String Str
	Variable Np,Nq
	
	
	
	Str=StrVarOrDefault("root:TopImageWinName","nop!")
	If(stringmatch(str,"nop!"))
		String/G TopImageWaveName,TopImageWinName
	Else
		Svar TopImageWaveName,TopImageWinName
	EndIf
	TopImageWinName=WinName(0,1,1)
	TopImageWaveName=StringFromList(0,ImageNameList("",";"),";")
	Np=round(dimsize($TopImageWaveName,0)/2)
	Nq=round(dimsize($TopImageWaveName,1)/2)
	
	If(Exists("XPart")==1&&Exists("YPart")==1)
		KillWaves/Z XPart,YPart
		DrawAction/W=$TopImageWinName delete
	EndIf		
		
	cursor/C=(65535,0,0)/F/I/H=1/W=$TopImageWinName A, $TopImageWaveName,Np,Nq
	Button PartAddButton win=$TopImageWinName,title="Add Part.",pos={450,430},size={60,18},proc=PartAdd,disable=0//,appearance={os9}
	Button PartRemoveButton win=$TopImageWinName,title="Rmve Part.",pos={450,450},size={60,18},proc=PartRemove,disable=0//,appearance={os9}
	Button PartStartButton win=$TopImageWinName,title="Start",pos={450,470},size={60,18},proc=PartStart,disable=0//,appearance={os9}
	
	//Doalert 0,"Select Particles from the top to the bottom of the picture"
End


Function PartAdd(ctrlName) : ButtonControl
	String ctrlName
	
	Svar TopImageWinName
	
	String Str
	
	If(Exists("XPart")==0&&Exists("YPart")==0)
		Make/D/N=1/O XPart,YPart
		Xpart[0]=hcsr(A)
		Ypart[0]=vcsr(A)
		
		Str="Text"+num2str(0)
	Else
		Wave XPart,YPart
		Wavestats/Q/Z/M=1 XPart
		Redimension/D/N=(V_npnts+1) XPart,YPart
		Xpart[V_npnts]=hcsr(A)
		Ypart[V_npnts]=vcsr(A)
		
		Str="Text"+num2str(V_npnts)			
	EndIf
	//ShowTools/A
	SetDrawEnv/W=$TopImageWinName textrgb= (2^32,0,0),fstyle= 1,xcoord= top,ycoord= left
	SetDrawEnv gname=$Str,gstart
	DrawText hcsr(A),vcsr(A)-10, num2str(V_npnts)
	SetDrawEnv gname=$Str,gstop	
	//HideTools/A		
End


Function PartRemove(ctrlName) : ButtonControl
	String ctrlName
	
	Svar TopImageWinName
	
	Wave XPart,YPart
	String Str
	
	TopImageWinName=WinName(0,1,1)
	
	Wavestats/Q/Z/M=1 XPart
	
	If(V_npnts>=0)
		Redimension/D/N=(V_npnts-1) XPart,YPart
		Str="Text"+num2str(V_npnts-1)
		DrawAction/W=$TopImageWinName getgroup=$Str, delete
	EndIf
	//Return V_npnts
End


Function PartStart(ctrlName) : ButtonControl
	String ctrlName
	
	Svar TopImageWaveName,TopImageWinName
	
	String/G OptionStr, BlackStr
	Variable/g i,j
	Variable Flag,NFramesToAnalyse,NPartToAnalyse
	String/G Perimeter_j,Area_j,X_j,Y_j
	String Str
	
	TopImageWinName=WinName(0,1,1)
	TopImageWaveName=StringFromList(0,ImageNameList("",";"),";")
	
	cursor/K/W=$TopImageWinName A
	Button PartAddButton win=$TopImageWinName,disable=1//,appearance={os9}
	Button PartRemoveButton win=$TopImageWinName,disable=1//,appearance={os9}
	Button PartStartButton win=$TopImageWinName,disable=1//,appearance={os9}
	
	
	Flag=FromToStepDialog(4)
	Nvar FromVar, ToVar, StepVar, RefRead,Threshold
	Svar YesNoStr
	
	NFramesToAnalyse=(ToVar-FromVar)/StepVar+1
	
	If(Exists("XPart"))
		Wave Xpart, Ypart
		WaveStats/M=1/Q XPart
		NPartToAnalyse=V_npnts
	Endif
	
	If(Flag==0)
		If(StringMatch(YesNoStr,"Yes"))
			// ROI mask used
			Print "Beginning Particle Analysis with ROI Mask"
			If(!Exists("M_ROIMask"))
				Abort "You need to create a ROI first"
			EndIf
			Wave M_ROIMask
			For(i=0; i<NFramesToAnalyse; i+=1)
				If(i==0)
					Wave 'Wave_i'=DAVLoadFrame(FromVar+i*StepVar,1)
					TopImageWinName=WinName(0,1,1)
					Make/D/N=1/O wFrameNr
				Else
					//Wave 'Wave_i'=DAVAdd(FromVar+i*StepVar,"No")					
					wave wFrameNr
					Redimension/N=(i+1) wFrameNr
				EndIf
				
				If(i==0) 
					CalculateAndAppendROIBoundary()
				Else
					AppendROIBoundary()
				EndIf
				Wave M_ROIMask_boundary
				
				wFrameNr[i]=FromVar+i*StepVar
				//Print nameofwave('Wave_i')				
				
				Str="ImageThreshold/Q/M="				
				If(stringmatch(OptionStr,"Iterative"))
					Str+="1"
				Else
					Str+="0/T="+num2Str(Threshold) 
				EndIf
				
				If(stringmatch(BlackStr,"Yes"))
					Str+="/I"
				EndIf
								
				Str+="/R=M_ROIMask "
				Str+=nameofwave('Wave_i')
				//Print Str				
				Execute Str //ImageThreshold/Q/M=1/R=M_ROIMask 'Wave_i'
				Wave M_ImageThresh
				
				M_ImageThresh=(M_ImageThresh*(-1*M_ROIMask+1))
				If(stringmatch(BlackStr,"Yes"))
					
					M_ImageThresh=M_ImageThresh-255
				Else	
					M_ImageThresh=-1*M_ImageThresh+255
				EndIf
				
				redimension/B/U M_ImageThresh
				Duplicate /O	M_ImageThresh, M_Particles;M_Particles=64
				//NewImage/K=1 M_ImageThresh
//				ImageAnalyzeParticles/M=3/Q/R=M_ROIMask stats, M_ImageThresh							
//				Wave W_ImageObjArea, M_Particle, W_SpotX, W_SpotY
				print "     Frame",FromVar+i*StepVar
				For(j=0; j<NPartToAnalyse; j+=1)
					Perimeter_j="Perimeter_"+num2str(j)
					Area_j="Area_"+num2str(j)
					X_j="X_"+num2str(j)
					Y_j="Y_"+num2str(j)
					
					Make/D/N=(i+1)/O $Perimeter_j /wave=w3
					Make/D/N=(i+1)/O $Area_j /wave=w0
					Make/D/N=(i+1)/O $X_j /wave=w1
					Make/D/N=(i+1)/O $Y_j /wave=w2
					print "           Part",j
					Print Xpart[j], Ypart[j]
//					ImageAnalyzeParticles /Q/M=3/A=100/R=M_ROIMask/F stats, M_ImageThresh
					
					// determines a mask of the jth particle and generates M_ParticleMarker char wave with value of 64 outside and 0 inside the particle
					ImageAnalyzeParticles/L=(Xpart[j], Ypart[j])/R=M_ROIMask/F mark, M_ImageThresh
					Wave M_ParticleMarker
					//ImageAnalyzeParticles/L=(Xpart[j], Ypart[j])/EBPC/R=M_ROIMask/F mark, M_ImageThresh
					//ImageAnalyzeParticles/L=(564,776)/EBPC/R=M_ROIMask/F mark, M_ImageThresh
					MatrixOp/O M_ParticleMarker=M_ParticleMarker/64
					MatrixOp/O M_ParticleMarker=M_ParticleMarker*255
					redimension/B/U M_ParticleMarker	
					//ImageMorphology/O/E=(1)/I=(1) Erosion, M_ParticleMarker
					//NewImage/K=1 M_ParticleMarker
					
					// works out the stats of the jth particle (area, perimeter, position)
					ImageAnalyzeParticles /M=3/R=M_ROIMask/F stats, M_ParticleMarker
					//ImageSeedFill /B=255/R=M_ROIMask SeedP=Xpart[j], SeedQ=Ypart[j], target=0, srcWave=M_ImageThresh
					//ImageSeedFill /B=255/R=M_ROIMask SeedP=564, SeedQ=776, target=0, srcWave=M_ImageThresh
					//NewImage/K=1 M_SeedFill
					//ImageAnalyzeParticles/M=3/R=M_ROIMask/F stats, M_SeedFill
					Wave W_ImageObjPerimeter,W_ImageObjArea, M_Particle, W_SpotX, W_SpotY, M_rawMoments
					//Print W_SpotX[0], W_SpotY[0]
					Print M_rawMoments[0][0]/W_ImageObjArea[0], M_rawMoments[0][1]/W_ImageObjArea[0]
					Print M_rawMoments[0][0], M_rawMoments[0][1], W_ImageObjArea[0],W_ImageObjPerimeter[0]	
					
//					If((W_SpotX[0]!=NaN) && (W_SpotY[0]!=NaN))
//						print " recording ..." 
//						w0[i]=W_ImageObjArea[0]
//						w1[i]=W_SpotX[0]
//						w2[i]=W_SpotY[0]
//						Xpart[j]=W_SpotX[0]
//						Ypart[j]=W_SpotY[0]
//						MatrixOp/O M_Particles=M_Particles-M_Particle
						//redimension/B/U M_Particles
//					Else
//					If(W_SpotX[j]!=NaN && W_SpotY[j]!=NaN)
//						w0[i]=W_ImageObjArea[j]
//						w1[i]=W_SpotX[j]
//						w2[i]=W_SpotY[j]
//						Xpart[j]=W_SpotX[j]
//						Ypart[j]=W_SpotY[j]
//					Else
//						Abort "W_SpotX[j] is NaN"
//					EndIf
					//Wavestats/Q/M=1 W_SpotX
					//If(V_numNaNs!=0)
					If(numtype(W_SpotX[j])==2)
						String PromptString
						PromptString="W_SpotX["
						PromptString+=num2str(j)
						PromptString+= "] is NaN"			
						//DoAlert 0, PromptString
						
						
						TopImageWinName=WinName(0,1,1)
						TopImageWaveName=StringFromList(0,ImageNameList("",";"),";")
						
						DoWindow/F $TopImageWinName
						cursor/C=(65535,0,0)/I/H=1/W=$TopImageWinName A, $TopImageWaveName,Xpart[j],Ypart[j]
						ShowInfo/CP=0/W=$TopImageWinName
						
						
						NewPanel /K=2 /W=(40,619,246,716) as "Pause for User"
						DoWindow/C PauseforCursor					// Set to an unlikely name
						AutoPositionWindow/E/M=0/R=$TopImageWinName		// Put panel near the graph
						DrawText 21,20,PromptString
						DrawText 21,37,"Adjust the cursor to the particle "+num2str(j)
						DrawText 21,54,"and then Click Continue. Or Skip."
						Button button0,pos={49,56},size={92,20},title="Continue"
						Button button0, proc=KillPauseforCursorPanel
						Button button1,pos={49,76},size={92,20},proc=KillPauseforCursorPanelAndSkip,title="Skip"
						
						DoWindow/F $TopImageWinName
						
						PauseForUser PauseforCursor,$TopImageWinName
						HideInfo/W=$TopImageWinName
										
					Else
						//print " recording ..." 
						w3[i]=W_ImageObjPerimeter[0]
						w0[i]=W_ImageObjArea[0]
						//w1[i]=W_SpotX[0]
						//w2[i]=W_SpotY[0]
						w1[i]=M_rawMoments[0][0]/W_ImageObjArea[0]
						w2[i]=M_rawMoments[0][1]/W_ImageObjArea[0]					
						MatrixOp/O M_Particles=M_Particles-M_Particle
						Xpart[j]=w1[i]
						Ypart[j]=w2[i]
						
						MatrixOp/O M_Particles=M_Particles+(NPartToAnalyse-1)*64
											
			
					EndIf
					
//					AppendImage/T/W=$TopImageWinName M_Particle
//					
//					If(j==0)
//						Str="M_Particle"
//					Else
//						Str="M_Particle"+"#"+num2str(j)
//					EndIf
//					//Print Str
//					ModifyImage/W=$TopImageWinName $Str,explicit=1,eval={16, 65535, 0, 0}
//					DoUpdate/W=$TopImageWinName
				EndFor
				
				AppendImage/T/W=$TopImageWinName M_Particles
		//		ModifyImage/W=$TopImageWinName M_Particles,explicit=1,eval={16, 65535, 0, 0}
				ModifyImage/W=$TopImageWinName M_Particles ctab= {65,70,Grays,0}, minRGB=NaN,maxRGB=(65280,0,0)
				DoUpdate/W=$TopImageWinName
				
				
				If(i!=NFramesToAnalyse-1)
					Str=nameofwave('Wave_i')	
					//Print Str			
					RemoveImage/W=$TopImageWinName $Str
					If(i!=0) 
						killwaves 'Wave_i'
					EndIf
					Wave 'Wave_i'=DAVAddFrame(FromVar+(i+1)*StepVar,"No")
				EndIf
				
//				For(j=0; j<NPartToAnalyse; j+=1)
//					If(j==0)
//						Str="RemoveImage/W="+TopImageWinName+" M_Particle#"+num2str(NPartToAnalyse-1)
//					Else
//						If(NPartToAnalyse-1-j==0)
//							Str+=",M_Particle"
//						Else
//							Str+=",M_Particle"+"#"+num2str(NPartToAnalyse-1-j)
//						EndIf
//					EndIf
//				EndFor
//				//Print Str
//				Execute Str
				RemoveImage/W=$TopImageWinName M_Particles
//				RemoveImage/W=$TopImageWinName M_ROIMask_boundary
				
				DoUpdate/W=$TopImageWinName
				
//				AppendImage/T/W=$TopImageWinName M_Particle
//				ModifyImage/W=$TopImageWinName M_Particle,explicit=1,eval={16, 65535, 0, 0}
//				DoUpdate/W=$TopImageWinName
			EndFor
//			AppendImage/T/W=$TopImageWinName M_Particle
//			ModifyImage/W=$TopImageWinName M_Particle,explicit=1,eval={16, 65535, 0, 0}
//			DoUpdate/W=$TopImageWinName
			
			//Print "Ending Particle Analysis"
			
//------------------------------Showing Results-----------------------------------------------------------------------------------------------------//			
			For(j=0; j<NPartToAnalyse; j+=1)
				Perimeter_j="Perimeter_"+num2str(j)
				Area_j="Area_"+num2str(j)
				X_j="X_"+num2str(j)
				Y_j="Y_"+num2str(j)
				If(j==0)
					display/K=1/N=Perimeters $Perimeter_j vs wFrameNr
					display/K=1/N=Areas $Area_j vs wFrameNr
					display/K=1/N=PartPosition/T $Y_j vs $X_j
				Else
					AppendToGraph/W=Perimeters $Perimeter_j vs wFrameNr
					AppendToGraph/W=Areas $Area_j vs wFrameNr
					AppendTograph/T/W=PartPosition $Y_j vs $X_j
				EndIf
				ModifyGraph/W=Areas rgb($Area_j)=(2^32*j^3/NPartToAnalyse^3,2^32*j^2/NPartToAnalyse^2,2^32*j/NPartToAnalyse)
				//ModifyGraph rgb($Area_j)=(abs(enoise(2^32-1)),abs(enoise(2^32-1)),abs(enoise(2^32-1)))			
				ModifyGraph/W=Areas mode=4,marker=19,lsize=1.5
				
				
				ModifyGraph/W=Perimeters rgb($Perimeter_j)=(2^32*j^3/NPartToAnalyse^3,2^32*j^2/NPartToAnalyse^2,2^32*j/NPartToAnalyse)
				//ModifyGraph rgb($Area_j)=(abs(enoise(2^32-1)),abs(enoise(2^32-1)),abs(enoise(2^32-1)))			
				ModifyGraph/W=Perimeters mode=4,marker=19,lsize=1.5
				AutoPositionWindow/M=0/R=Areas Perimeters
				
				
				ModifyGraph/W=PartPosition rgb($Y_j)=(2^32*j^3/NPartToAnalyse^3,2^32*j^2/NPartToAnalyse^2,2^32*j/NPartToAnalyse)
				//ModifyGraph rgb($Area_j)=(abs(enoise(2^32-1)),abs(enoise(2^32-1)),abs(enoise(2^32-1)))			
				ModifyGraph/W=PartPosition mode=4,marker=19,lsize=1.5
				SetAxis/W=PartPosition top 0,1024
				SetAxis/W=PartPosition/R left 1024,0
				AutoPositionWindow/M=0/R=Perimeters PartPosition
			EndFor
			
			Legend/W=Perimeters
			Label/W=Perimeters left "\\Z12Perimeter (pix)"
			Label/W=Perimeters bottom "\\Z12 Frame Number"
			
			Legend/W=Areas
			Label/W=Areas left "\\Z12Area (pix\\S2\\M)"
			Label/W=Areas bottom "\\Z12 Frame Number"
			
			Legend/W=PartPosition
			//SetAxis/A/R/W=PartPosition left
			Label/W=PartPosition left "\\Z12Y(pix)"
			Label/W=PartPosition top "\\Z12 X(pix)"
			
		Else
			Abort "ROI-mask-not-used option not implemented yet !"
			// ROI mask not used
		EndIf
	EndIf
	Button PartAddButton win=$TopImageWinName,disable=3//,appearance={os9}
	Button PartRemoveButton win=$TopImageWinName,disable=3//,appearance={os9}
	Button PartStartButton win=$TopImageWinName,disable=3//,appearance={os9}
	cursor/K/W=$TopImageWinName A	
	//WMCreateImageParticlePanel()
End

Function KillPauseforCursorPanel(ctrlName) : ButtonControl
	String ctrlName
	Nvar j
	Wave Xpart, Ypart
	
	Xpart[j]=pcsr(A); Ypart[j]=qcsr(A)	
	j-=1
	DoWindow/K PauseforCursor
End

Function KillPauseforCursorPanelAndSkip(ctrlName) : ButtonControl
	String ctrlName
	
	Nvar i,j
	Wave Xpart, Ypart
	Svar Perimeter_j,Area_j, X_j, Y_j
	
	wave loc_Area_j=$Area_j 
	wave loc_Perimeter_j=$Perimeter_j 
	wave loc_X_j=$X_j
	wave loc_Y_j=$Y_j
	
	loc_Area_j[i]=0
	loc_Perimeter_j[i]=0
	loc_X_j[i]=pcsr(A) 
	loc_Y_j[i]=qcsr(A)
//	print "           Part",j
//	Xpart[j]=w1[i]
//	Ypart[j]=w2[i]		
//	Print Xpart[j], Ypart[j]
	Xpart[j]=pcsr(A); Ypart[j]=qcsr(A)	
	j+=1
	
	DoWindow/K PauseforCursor
End


//Function Test()
//wave W_spotX
//if(W_SpotX[0]==NaN)
//print "W_SpotX[0]=NaN"
//else
//print "W_SpotX[0]!=NaN"
//endif
//end