//----------------------------------------------------------------------------------------------------------------------------------------------------------//
//								Region Of Interest Functions										//
//																								// 
//										F. Cheynis												//
//																								//
//										28/04/2015												//
//----------------------------------------------------------------------------------------------------------------------------------------------------------//


#pragma rtGlobals=1		// Use modern global access method.

#include <Image ROI>

//Already in LEEM_Analysis2015
//Function/Wave FromROIToROIImage(WName)
//	String WName
//	//print WName
////Function FindROIRect()
//	
//	Variable i=0,j=0, Ncol, Nrow, BreakFlag=0
//	Wave M_ROIMask
//	Struct Rect ROIRect
//	
////	Svar TopImageWinName
////	If (!SVAR_Exists(TopImageWinName))	// No such global string variable?
////		String /G TopImageWinName=WinName(0,1,1)
////	endif
//	
//	If(!Exists("M_ROIMask"))
//		Abort "You need to create a ROI first"
//	Else
//		Nrow=dimsize(M_ROIMask,0)
//		Ncol=dimsize(M_ROIMask,1)
//		
//		do
//			For(i=0;i<Nrow;i+=1)
//				if(M_ROIMask[i][j]==0)
//					ROIRect.top=j-1
//					//Print "Top=", ROIRect.top
//					BreakFlag=1
//					break
//				EndIf
//			EndFor
//			j+=1
//		while((j<Ncol)&&(BreakFlag==0))
//		
//		i=0;j=0;BreakFlag=0		
//		do
//			For(j=0;j<Ncol;j+=1)
//				if(M_ROIMask[i][j]==0)
//					ROIRect.left=i-1
//					//Print "Left=", ROIRect.left
//					BreakFlag=1
//					break
//				EndIf
//			EndFor
//			i+=1
//		while((i<Nrow)&&(BreakFlag==0))
//		
//		i=0;j=Ncol;BreakFlag=0	
//		do
//			For(i=0;i<Nrow;i+=1)
//				if(M_ROIMask[i][j]==0)
//					ROIRect.bottom=j+1
//					//Print "Bottom=", ROIRect.bottom
//					BreakFlag=1
//					break
//				EndIf
//			EndFor
//			j-=1
//		while((j>=0)&&(BreakFlag==0))
//		
//		i=Nrow;j=0;BreakFlag=0	
//		do
//			For(j=0;j<Ncol;j+=1)
//				if(M_ROIMask[i][j]==0)
//					ROIRect.right=i+1
//					//Print "Right=", ROIRect.right
//					BreakFlag=1
//					break
//				EndIf
//			EndFor
//			i-=1
//		while((i>=0)&&(BreakFlag==0))
//				
//		//SetDrawEnv fillpat= 0,linefgc= (65280,0,0),xcoord= top,ycoord= left
//		//DrawRect ROIRect.left, ROIRect.top, ROIRect.right,ROIRect.bottom
//		//FromROIRectToROIImage(ROIRect)
//		//return ROIRect						
//	EndIf
////End
//
////Function FromROIRectToROIImage(ROIRect)
//	
//	//Struct Rect &ROIRect
//	//Variable i=0,j=0, Ncol, Nrow, BreakFlag=0
//	String ExctractedWaveName
//	//Wave M_ROIMask
//	
////	Svar/Z TopImageWaveName		// /Z prevents debugger from flagging bad SVAR
////	if (!SVAR_Exists(TopImageWaveName))	// No such global string variable?
////		String /G TopImageWaveName=StringFromList(0, ImageNameList("",";"))
////	endif
//	
//	If(!Exists("M_ROIMask"))
//		Abort "You need to create a ROI first"
//	Else
//		ExctractedWaveName=WName+"_extracted"
//		make/O/D/N=(DimSize($WName,0), DimSize($WName,1)) $ExctractedWaveName /Wave=ExctractedWave
//		Wave TopImageWave=$WName
//		
//		Redimension/B M_ROIMask
//		MatrixOP/O ExctractedWave=TopImageWave*((-1)*M_ROIMask+1)
//		ExctractedWave=ExctractedWave[p+ROIRect.left][q+ROIRect.top]
//		Redimension/N=(ROIRect.right-ROIRect.left,ROIRect.bottom-ROIRect.top) ExctractedWave
//		
//		//Print (ROIRect.right-ROIRect.left), (ROIRect.bottom-ROIRect.top)
//		//NewImage/K=1 ExctractedWave
//		return ExctractedWave
//	EndIf
//End

// Create a 2D of the surface WorkFonction from IV dav files
Function/WAVE WF2DMap2009()

	Nvar FromVar, ToVar, StepVar
	SVar TopImageWinName
	Variable Flag, i,j,k,NFramesToScan
	
	If(!Exists("M_ROIMask"))
		Abort "You need to create a ROI first"
	Endif
	If((!Exists("StartVoltW")))
		Abort "You need to cto extract the sequence overlays"
	EndIf
		
	Flag=FromToStepDialog(7)
	NFramesToScan=(ToVar-FromVar)/StepVar+1	
	
	If(Flag==0)
		Wave StartVoltW
		
		Print "Workfunction Measurements"
		If(!Exists("WF2DMapW"))
			make/D/O/N=(1024,1024) WF2DMapW
			make/D/O/N=(1024,1024) MaxW	
		Else
			Wave  WF2DMapW,MaxW
		EndIf
		
		Dowindow/K $TopImageWinName
		
		For(i=0; i<NFramesToScan; i+=1)
			Wave 'Wave_i'=DAVLoadFrame2009(FromVar+i*StepVar,0)
			MatrixFilter /N=3/P=1 avg 'Wave_i'
			  
			If(i==0)
				WF2DMapW=nan
				MaxW='Wave_i'
				MatrixFilter /N=3/P=1 avg MaxW
//				MatrixFilter /N=3/P=1/R=M_ROIMask avg MaxW				
			Else
//			MaxW='Wave_i'[p][q]>=MaxW[p][q] ? 'Wave_i'[p][q] : MaxW[p][q] 
			WF2DMapW='Wave_i'[p][q]> 0.92*MaxW[p][q] ? StartVoltW[FromVar+i*StepVar] :  WF2DMapW[p][q]
//				For(j=0;j<1024;j+=1)
//					For(k=0;k<1024;k+=1)
//						if('Wave_i'[j][k]>=MaxW[j][k])
//							MaxW[j][k]='Wave_i'[j][k] 
//						Else
//							MaxW[j][k]=MaxW[j][k] 
//						Endif
//				
//						If('Wave_i'[j][k]> 0.9*MaxW[j][k])
//							WF2DMapW[j][k]= StartVoltW[i]
//						Else
//							WF2DMapW[j][k]=WF2DMapW[j][k]
//						Endif
//					EndFor
//				EndFor
				
			Endif
			
		 	 KillWaves 'Wave_i'
		EndFor
		
	Endif
	return WF2DMapW
End





//Intensity measurements
Function DAVROI2009(ctrlName) : ButtonControl
	String ctrlName

	Nvar FromVar, ToVar, StepVar
	
	Variable Flag, i,NFramesToScan
		
	Flag=FromToStepDialog(5)
	NFramesToScan=(ToVar-FromVar)/StepVar+1	
	
	If(Flag==0)
		If(WaveExists(M_ROIMask_averaged))
			KillWaves M_ROIMask_averaged
		EndIf
		Print "Intensity measurements"
		For(i=0; i<NFramesToScan; i+=1)
			Wave 'Wave_i'=DAVLoadFrame2009(FromVar+i*StepVar,0)
			Wave ROIMask_averaged=AverageROI(nameofwave('Wave_i'))
			
//			If(i==0) 
//				CalculateAndAppendROIBoundary()
//			Else
//				AppendROIBoundary()
//			EndIf
		EndFor
		
		display/K=1/N=Averaged_ROI ROIMask_averaged
		ModifyGraph/W=Averaged_ROI mode=4,marker=19,lsize=1.5
		Legend "ROIMask_averaged"
	Endif
End


//Function/wave AverageROI(FrameName)
//
//	String FrameName
//	Wave M_ROIMask//,M_ROIMask_averaged
//	Variable n
//		
//	If(!Exists("M_ROIMask"))
//		Abort "You need to create a ROI first"
//	Else
//		If(!WaveExists(M_ROIMask_averaged))
//			Make /D/N=1 M_ROIMask_averaged
//			n=0	
//		Else
//			Wavestats/M=1/Z/Q M_ROIMask_averaged
//			n=V_npnts
//			Redimension /N=(n+1) M_ROIMask_averaged	   
//		EndIf
//		Imagestats /M=1/R=M_ROIMask $FrameName
//		//Imagestats /R=M_ROIMask $FrameName
//		M_ROIMask_averaged[n]=V_npnts*V_avg
//		
//		KillWaves/Z $FrameName
//	EndIf
//	
//	Return M_ROIMask_averaged
//End

//Already in LEEM_Analysis2015
//Function AppendROIBoundary()
//
//	String Str	
//	Str=StrVarOrDefault("root:TopImageWinName","nop!")
//	If(stringmatch(str,"nop!"))
//		String/G TopImageWinName
//	Else
//		Svar TopImageWinName
//	EndIf
//	TopImageWinName=WinName(0,1,1)
//	
//	If(!Exists("M_ROIMask"))
//		Abort "You need to create a ROI first"
//	Else
//		//Wave M_ROIMask
//		//SetDrawEnv/W=$StrTopImageWinName linefgc= (1,2^32,1),fillpat= 0,xcoord= top,ycoord= left
//		//ImageEdgeDetection/M=0/T=0.5 kirsch M_ROIMask
//		RemoveImage /W=$TopImageWinName M_ROIMask_boundary //Duplicate/O M_ImageEdges, M_ROIMask_boundary;Killwaves M_ImageEdges
//		Redimension/B/U M_ROIMask_boundary
//		AppendImage /W=$TopImageWinName/T M_ROIMask_boundary;DelayUpdate
//		//ModifyImage/W=$StrTopImageWinName M_ROIMask,explicit=1,eval={16, 0, 2^32, 0}
//		//ModifyImage M_ROIMask_boundary explicit=0,ctab= {1,2,Grays,0};DelayUpdate
//		//ModifyImage M_ROIMask_boundary minRGB=(0,39168,0),maxRGB=NaN
//		
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary minRGB=(0,39168,0),maxRGB=NaN
//		ModifyImage/W=$TopImageWinName M_ROIMask_boundary minRGB=NaN,maxRGB=(0,39168,0)
//		
//		//DoUpdate/W=$TopImageWinName
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary ctab= {-1,-1,Grays,0}
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary ctab= {1,2,Grays,0}
//		ModifyImage/W=$TopImageWinName M_ROIMask_boundary ctab= {0,0,Grays,0}
//		
//		
//		DoUpdate/W=$TopImageWinName
//	EndIf
//End

//Already in LEEM_Analysis2015
//Function CalculateAndAppendROIBoundary()
//
//	String Str	
//	Str=StrVarOrDefault("root:TopImageWinName","nop!")
//	If(stringmatch(str,"nop!"))
//		String/G TopImageWinName
//	Else
//		Svar TopImageWinName
//	EndIf
//	TopImageWinName=WinName(0,1,1)
//	
//	If(!Exists("M_ROIMask"))
//		Abort "You need to create a ROI first"
//	Else
//		Wave M_ROIMask
//		//SetDrawEnv/W=$StrTopImageWinName linefgc= (1,2^32,1),fillpat= 0,xcoord= top,ycoord= left
//		//ImageEdgeDetection/M=0/T=0.5 kirsch M_ROIMask
//		//Duplicate/O M_ImageEdges, M_ROIMask_boundary;Killwaves M_ImageEdges
//		
//		Duplicate/O M_ROIMask, M_ROIMask_boundary
//		MatrixFilter/N=(3)/P=(1) FindEdges, M_ROIMask_boundary
//		
//		Redimension/B/U M_ROIMask_boundary		
//		AppendImage /W=$TopImageWinName/T M_ROIMask_boundary;DelayUpdate
//		
//		
//		
//		//ModifyImage M_ROIMask_boundary ctab= {1,2,Grays,0};DelayUpdate
//		//ModifyImage M_ROIMask_boundary minRGB=(0,39168,0),maxRGB=NaN
//		ModifyImage M_ROIMask_boundary ctab= {0,0,Grays,0};DelayUpdate
//		ModifyImage M_ROIMask_boundary minRGB=NaN,maxRGB=(0,39168,0)
//		
//		
//		//ModifyImage/W=$StrTopImageWinName M_ROIMask,explicit=1,eval={16, 0, 2^32, 0}
//		//ModifyImage M_ROIMask_boundary explicit=0,ctab= {1,2,Grays,0};DelayUpdate
//		//ModifyImage M_ROIMask_boundary minRGB=(0,39168,0),maxRGB=NaN
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary minRGB=(0,39168,0),maxRGB=NaN
//		//DoUpdate/W=$TopImageWinName
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary ctab= {-1,-1,Grays,0}
//		//ModifyImage/W=$TopImageWinName M_ROIMask_boundary ctab= {1,2,Grays,0}
//		DoUpdate/W=$TopImageWinName
//	EndIf
//End